package com.zx.dataservice.controller;

import com.zx.dataservice.config.ServerResponse;
import com.zx.dataservice.service.ChoiceStockService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/api/"})
@Api(value="获取板块信息")
public class ChoiceController {

    @Autowired
    private ChoiceStockService choiceService;

    // 获取Datafeed 配置数据
    @RequestMapping(value = {"getPlateInfo"}, method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value="获取东方财富板块信息", notes="获取东方财富板块信息")
    public ServerResponse getPlateInfo() {
        choiceService.getPlateInfo();
        return ServerResponse.createBySuccess();
    }

}
