package com.zx.dataservice.controller;

import com.zx.dataservice.config.ServerResponse;
import com.zx.dataservice.service.ChoiceStockService;
import com.zx.dataservice.service.CreatorService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/api/task"})
@Api(value="触发定时任务")
public class TaskController {

    @Autowired
    private ChoiceStockService choiceStockService;

    @Autowired
    private CreatorService creatorService;

    // 获取Datafeed 配置数据
    @RequestMapping(value = {"toTask"}, method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value="触发定时任务", notes="触发定时任务")
    public ServerResponse getPlateInfo() {
        choiceStockService.analysisStockRestData();
        return ServerResponse.createBySuccess();
    }

    // 获取Datafeed 配置数据
    @RequestMapping(value = {"creatorUvxy"}, method = RequestMethod.GET)
    @ResponseBody
    @ApiOperation(value="恐慌指数", notes="恐慌指数")
    public ServerResponse creatorUvxy() {
        creatorService.creatorUvxy();
        return ServerResponse.createBySuccess();
    }
}
