package com.zx.dataservice.task;

import com.zx.dataservice.service.ChoService;
import com.zx.dataservice.service.CreatorService;
import com.zx.dataservice.utils.BuyAndSellUtils;
import com.zx.dataservice.utils.DateTimeUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * 制造新股\新债实时数据
 */
@Component
public class MakeRestDataTask {

    private static final Logger log = LoggerFactory.getLogger(MakeRestDataTask.class);

    @Autowired
    private ChoService choService;

    @Autowired
    private CreatorService creatorService;

//    @Scheduled(cron = "0/3 * * * * ?")
    public void toMakeStockRestData() {
        log.info("=====定时任务===制造新股==开始，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
        choService.insertRtStock();
        log.info("=====定时任务===制造新股==结束，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
    }

//    @Scheduled(cron = "0/3 * * * * ?")
    public void toMakeBondRestData() {
        log.info("=====定时任务===制造新债==开始，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
        choService.insertRtBood();
        log.info("=====定时任务===制造新债==结束，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
    }

//    @Scheduled(cron = "0/3 * * * * ?")
    public void creatorUvxy() {
        try {
            if(BuyAndSellUtils.isTransTime("09:30", "12:00") || BuyAndSellUtils.isTransTime("13:00", "15:00")){
                log.info("=====定时任务===制造恐慌指数==实时==开始，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
                creatorService.creatorUvxy();
                log.info("=====定时任务===制造恐慌指数==实时==结束，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

//    @Scheduled(cron = "0 0 1 * * ?")
    public void creatorUvxyHist() {
        try {
            log.info("=====定时任务===制造恐慌指数==历史==开始，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
            creatorService.creatorUvxyHist();
            log.info("=====定时任务===制造恐慌指数==历史==结束，当前时间 {} =====", DateTimeUtil.dateToStr(new Date()));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
